
/*
PUBLIC KEY ENCRYPTION

*/

import java.applet.Applet;
import java.awt.*;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

public class Encrypt extends Applet
{

    public void init()
    {
        privatekey = new TextField[8];
        setLayout(new GridLayout(14, 1, 6, 6));
        add(new Label("1. Enter Private Key"));
        Panel panel = new Panel();
        setBackground(Color.lightGray);
        panel.setLayout(new GridLayout(1, 8));
        int i = 1;
        for(int j = 0; j < 8; j++)
        {
            panel.add(privatekey[j] = new TextField(String.valueOf(i)));
            i *= 2;
        }

        add(panel);
        add(new Label("2. Enter Multiplier and Modulus and Press Record"));
        Panel panel1 = new Panel();
        panel1.setLayout(new GridLayout(1, 6));
        panel1.add(new Label("Multiplier"));
        panel1.add(multiplier = new TextField("4571"));
        panel1.add(new Label("Modulus"));
        panel1.add(modulus = new TextField("7187"));
        panel1.add(new Label(""));
        panel1.add(record = new Button("Record"));
        add(panel1);
        add(new Label("Public Key"));
        Panel panel2 = new Panel();
        panel2.setLayout(new GridLayout(1, 8));
        publickey = new TextField[8];
        for(int k = 0; k < 8; k++)
            panel2.add(publickey[k] = new TextField(""));

        add(panel2);
        add(new Label("3. Enter Text Message"));
        add(plaintext = new TextField(""));
        Panel panel3 = new Panel();
        panel3.setLayout(new GridLayout(1, 4));
        panel3.add(new Label(""));
        panel3.add(new Label("4. Press Encrypt"));
        panel3.add(new Label(""));
        panel3.add(encodebutton = new Button("Encrypt"));
        add(panel3);
        add(new Label("Encoded Message"));
        add(encode = new TextField(""));
        Panel panel4 = new Panel();
        panel4.setLayout(new GridLayout(1, 4));
        panel4.add(new Label(""));
        panel4.add(new Label("5. Press Decrypt"));
        panel4.add(new Label(""));
        panel4.add(decodebutton = new Button("Decrypt"));
        add(panel4);
        add(new Label("Decoded Message"));
        add(decode = new TextField(""));
    }

    public int getInt(TextField textfield)
    {
        return Integer.parseInt(textfield.getText());
    }

    public void setInt(int i, TextField textfield)
    {
        textfield.setText(String.valueOf(i));
    }

    public void superIncrease()
    {
        int i = getInt(privatekey[0]);
        for(int j = 1; j < 8; j++)
        {
            if(i >= getInt(privatekey[j]))
                setInt(i + 1, privatekey[j]);
            i += getInt(privatekey[j]);
        }

        if(getInt(modulus) <= getInt(privatekey[7]))
            setInt(getInt(privatekey[7]) + 1, modulus);
    }

    public int modulo(int i, int j)
    {
        return i - (i / j) * j;
    }

    public void computePublicKey()
    {
        for(int i = 0; i < 8; i++)
            setInt(modulo(getInt(privatekey[i]) * getInt(multiplier), getInt(modulus)), publickey[i]);

    }

    public static int translateChar(char c, TextField atextfield[])
    {
        int i = 0;
        for(int j = 0; j < 8; j++)
        {
            if(2 * (c / 2) != c)
                i += Integer.parseInt(atextfield[j].getText());
            c /= '\002';
        }

        return i;
    }

    public void computeEncodedText()
    {
        String s = new String("");
        String s1 = new String(plaintext.getText());
        int i = s1.length();
        if(i <= 0)
            return;
        s = String.valueOf(translateChar(s1.charAt(0), publickey));
        for(int j = 1; j < i; j++)
            s += "+" + String.valueOf(translateChar(s1.charAt(j), publickey));

        encode.setText(s);
    }

    public int xlateBack(int i)
    {
        int j = 128;
        int k = 0;
        for(int l = 7; l >= 0 && i > 0; l--)
        {
            if(Integer.parseInt(privatekey[l].getText()) <= i)
            {
                i -= Integer.parseInt(privatekey[l].getText());
                k += j;
            }
            j /= 2;
        }

        return k;
    }

    public int inverse()
    {
        int j = getInt(multiplier);
        int k = getInt(modulus);
        for(int l = 1; l < k; l++)
        {
            int i = 0;
            for(int i1 = 0; i1 < k; i1++)
            {
                if(modulo(l * modulo(j * i1, k), k) != i1)
                    break;
                i++;
            }

            if(i == k)
                return l;
        }

        return 0;
    }

    public void computeDecodeText(String s)
    {
        String s1 = new String("");
        int j = inverse();
        try
        {
            StringTokenizer stringtokenizer = new StringTokenizer(s, "+");
            do
            {
                int i = Integer.parseInt(stringtokenizer.nextToken());
                s1 += (char)xlateBack(modulo(j * i, getInt(modulus)));
            } while(true);
        }
        catch(NoSuchElementException _ex)
        {
            decode.setText(s1);
        }
    }

    public boolean action(Event event, Object obj)
    {
        for(int i = 0; i < 8; i++)
            if(event.target.equals(privatekey[i]))
            {
                superIncrease();
                return true;
            }

        if(event.target.equals(record))
        {
            computePublicKey();
            return true;
        }
        if(event.target.equals(encodebutton))
        {
            computeEncodedText();
            return true;
        }
        if(event.target.equals(decodebutton))
        {
            computeDecodeText(encode.getText());
            return true;
        } else
        {
            return super.action(event, obj);
        }
    }

    public boolean handleEvent(Event event)
    {
        if(event.id == 201)
            System.exit(0);
        return super.handleEvent(event);
    }

    public Encrypt()
    {
    }

    TextField plaintext;
    TextField encode;
    TextField decode;
    TextField multiplier;
    TextField modulus;
    TextField privatekey[];
    TextField publickey[];
    Button record;
    Button encodebutton;
    Button decodebutton;
}
