/*	
				 Sliding Window Protocol Simulation.
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class gobackn extends Applet implements ActionListener, Runnable{
	static Canvas2 canvas;
	menu_2 choice;
	Help helpframe = new Help("Help");
	Button start, stop1, pause, options, helpbutton;
	Thread current = null;
	boolean paused = true;
	boolean clear = false;
	int delay = 0;
	int type = 0;
	int end = 9;
	int lossnoa = 3;	//sender.
	int lossnob = 3;    //receiver.

	public String getAppletInfo(){
		return "Project Title :- Sliding window Protocal";
		}

	public void init(){
		setBackground(Color.lightGray);
		setSize(640, 470);
		add(canvas = new Canvas2());
		canvas.setSize(640, 370);
		choice = new menu_2("  *  Simulation Parameters  *  ");
		choice.setSize(500, 400);
		choice.setLocation(70, 25);
		add(start   = new Button("  Start  ")); //Add control buttons.
		add(stop1   = new Button("  Stop   "));
		add(pause   = new Button("  Pause  "));
		add(options = new Button(" Change Settings "));
		add(helpbutton    = new Button("  Help  "));
		start.addActionListener(this);
		stop1.addActionListener(this);
		pause.addActionListener(this);
		options.addActionListener(this);
		helpbutton.addActionListener(this);
		stop1.setEnabled(false);            //Initially only the 'Start'
		pause.setEnabled(false);			 //button is enabled.
		}

	public void actionPerformed(ActionEvent event){
		if (event.getSource() == start){
			if (helpframe.isVisible()){
				helpframe.setVisible(false);
				canvas.repaint();
				}
			Start();
			}
		if (event.getSource() == stop1){
			Stops();
			}
		if (event.getSource() == pause){
			PauseorResume();
			}
		if (event.getSource() == options){
			if (options.getLabel() .equals(" Change Settings ")){
				options.setLabel("  Done  ");
				choice.setVisible(true);
				start.setEnabled(false);
				}
			else {
				choice.setVisible(false);
				options.setLabel(" Change Settings ");
				canvas.sim = false;
				canvas.clear = true;
				canvas.repaint();
				delay = choice.getdelay();
				type = choice.gettype();
				end = choice.getend();
				lossnoa = choice.getlossnoa();
				lossnob = choice.getlossnob();
				canvas.setparam(type, end, lossnoa, lossnob);
				start.setEnabled(true);
				}
			}
		if (event.getSource() == helpbutton){
			 helpframe.setSize(590, 410);
			 helpframe.show();
			}
		}

	private void Start(){                    //Start simulation.
		start.setEnabled(false);
		stop1.setEnabled(true);
		options.setEnabled(false);
		helpbutton.setEnabled(false);
		pause.setLabel(" Pause ");
		pause.setEnabled(true);
		paused = false;
		canvas.sim = true;
//		canvas.damagedpno = 3;
		start();
		}

	private void Stops(){                    //Stop and reset simulation.
		if (current != null)
			current.stop();
		current = null;
		paused = true;
		canvas.sim = false;
		canvas.reset();
		canvas.repaint();
		stop1.setEnabled(false);
		start.setEnabled(true);
		options.setEnabled(true);
		helpbutton.setEnabled(true);
		pause.setLabel(" Pause ");
		pause.setEnabled(false);
		}

	private void PauseorResume(){            //Freeze or resume simulation.
		if (pause.getLabel() .equals(" Pause ")){
			if (current != null) {
				paused = true;
				current.suspend();
				}
			pause.setLabel("Resume");
			helpbutton.setEnabled(true);
			}
		else {
			pause.setLabel(" Pause ");
			helpbutton.setEnabled(false);
			paused = false;
			current.resume();
			}
		}

	public void start(){                     //Create a new thread.
		if (paused){
			}
		else{
			if (current == null){
				current = new Thread(this);
				current.setPriority(Thread.MIN_PRIORITY);
				current.start();
				}
			}
		}

	public void stop(){                      //Destroy the thread.
		current = null;
		}

	public void run(){                       //Thread control method.
		long startTime = System.currentTimeMillis();

		while (Thread.currentThread() == current){
			if (!paused) {
				canvas.repaint();
				if (canvas.complete == true){
					stop();
					Stops();
					return;
					}
				}
			try{
			    if (!clear)
					Thread.sleep(delay + 10);
			    else	Thread.sleep(delay);
			    }
			catch(InterruptedException e){}
			}
		}

	}

class Canvas2 extends Canvas{
	String s1 = "Sliding Window Protocol using Go Back 'n'";
	Font font;
	FontMetrics fontm;
	boolean sim = false;
	boolean clear = false;
	Dimension d;
	int seqno = 0, ackno = 0;
	Point send[], ack[];
	boolean sent[], preached[], areached[], timeout[];
	int current = 0;
	int damagedpno = -1;
	boolean loss = false;
	boolean done = false, allreached = false, complete = false;
	static int start, end;
	int lossnoa, lossnob;
	int type = 0;


	Canvas2(){
		super();
		ack  = new Point[1000];
		send = new Point[1000];
		for (int i = 0; i < 1000; i++){
			ack[i]  = new Point();
			send[i] = new Point();
			}
		sent = new boolean[1000];
		preached = new boolean[1000];
		areached = new boolean[1000];
		timeout  = new boolean[1000];
		end = 9;
		reset();
		}

	void reset(){
		done = complete = false;
		allreached = false;
		start = 0; //end = 5;
		int x = 50;
		for (int i = 0; i < 1000; i++){
			sent[i]     = false;
			preached[i] = false;
			areached[i] = false;
			timeout[i]  = false;
			send[i].y = 220;
			send[i].x = x;
			ack[i].y  = 290;
			ack[i].x  = x;
			x += 25;
			}
		}

	public void setparam(int type, int end, int lossnoa, int lossnob){
		this.type = type;
//		this.end = end;
		damagedpno = lossnoa;
		this.lossnob = lossnoa;
		start = 0;
		}


	public void paint(Graphics g){
		d = getSize();
		if (sim == false) {
			g.setFont(font = new Font("Times New Roman", Font.PLAIN | Font.BOLD, 18));
			fontm = getFontMetrics(font);
			g.setColor(Color.black);
			g.drawString(s1, (d.width - fontm.stringWidth(s1))/2, 30);
			g.setColor(getBackground());
			g.draw3DRect(0, 0, d.width - 5, d.height - 2, true);
			g.fill3DRect(40, 200, 560, 8, true);  //A
			g.fill3DRect(40, 300, 560, 8, true);  //B
			g.fillRect(40, 209, 560, 90);
			g.setFont(font = new Font("Times New Roman", Font.PLAIN | Font.BOLD, 14));
			fontm = getFontMetrics(font);
			g.setColor(Color.black);
			g.drawString("Sender", (d.width - fontm.stringWidth("Sender")) / 2 - 5, 190);
			g.drawString("Receiver", (d.width - fontm.stringWidth("Receiver")) / 2,
								300 + 10 + 18);
			g.setFont(font = new Font("Times New Roman", Font.PLAIN, 10));
			g.setColor(Color.green);
			g.fill3DRect(255, 70, 20, 8, true);
			g.setColor(Color.blue);
			g.fill3DRect(255, 90, 20, 8, true);
			g.setColor(Color.black);
			g.drawString("Data frame", 290, 78);
			g.drawString("Acknowledgement", 290, 98);
			g.setColor(getBackground());
			g.draw3DRect(245, 60, 150, 50, true);
			g.setFont(font = new Font("Times New Roman", Font.PLAIN, 9));
			}
		else {		//simulation in progress.
//			g.setFont(font = new Font("Times New Roman", Font.PLAIN, 9));
			if (!done){
				sendpackets(start, end, damagedpno);
				}
			else{
//				if ((end - start) > damagedpno){
				if (type != 0 && start + damagedpno > end){
					complete = true;
					return;
					}
				done = false;
				start += damagedpno;
				allreached = false;
				loss = false;
				send[start].x = send[end].x;
				for (int i = start; i <= end; i++){
					sent[i]     = false;
					preached[i] = false;
					areached[i] = false;
					timeout[i]  = false;
					send[i].y = 220;
					if (i != start) send[i].x = send[i - 1].x + 25;
					if (send[i].x > 550)
						send[i].x = 50;
					ack[i].y  = 290;
					}
//				else complete = true;
				}
			clear = !clear;
			//if (start >= end) done = true;
			}
		}

	void sendpackets(int start, int end, int damagedpno){
		Graphics g = getGraphics();

		if (clear) g.setColor(getBackground());
		if (!sent[start]) sent[start] = true;

		for (int i = start; i <= end; i++){
			seqno = i;
			if (type != 0 && i == start + damagedpno) loss = true;
			if (sent[i] && !preached[i]){
				if (send[i].y > 230 && i < end) sent[i + 1] = true;
				if (!clear){    //clear value is changed previously.
					send[i].x++;
					send[i].y += 2;
					}
				if (!clear){
					if ((type == 0 && send[i].y < 292) || (type != 0 && i == (start + damagedpno) && send[i].y < 255)
						|| (type != 0 && i != start + damagedpno && send[i].y < 292)){
						g.setColor(Color.green);
						g.fill3DRect(send[i].x, send[i].y, 20, 8, true);
						g.setColor(Color.black);
						g.drawString(String.valueOf(seqno),
								send[i].x + 7, send[i].y - 2);
						}
					else {
						if (send[i].y >= 292)
							preached[i] = true;
						ack[i].x = send[i].x + 10;
						if (ack[i].x > 550){
							if (i > 0 && ack[i - 1].x == 50)
								ack[i].x = 75;
							else ack[i].x = 50;
							}
						}
					}
				else g.fillRect(send[i].x, send[i].y - 11, 22, 20);
				}
			}

		allreached = true;
		for (int i = start; i <= end; i++){
			if (preached[i] == false) allreached = false;
			}

		for (int i = start; i <= end; i++){
			ackno = i;
			if (preached[i] && !areached[i]){
				if (!clear){
					ack[i].x++;
					ack[i].y -= 2;
					}
				if (!clear){
					if ((!loss || i < start + damagedpno) && ack[i].y > 218){
						g.setColor(Color.blue);
						g.fill3DRect(ack[i].x, ack[i].y, 20, 8, true);
						g.setColor(Color.black);
						g.drawString(String.valueOf(ackno),
								ack[i].x + 7, ack[i].y - 2);
						}
					else {
						areached[i] = true;
						}
					}
				else g.fillRect(ack[i].x, ack[i].y - 11, 22, 20);
				}
			}

		done = true;
		for (int i = start; i <= end; i++){
			if (i == start + damagedpno + 5)
				if (damagedpno != -1) timeout[damagedpno] = true;
			if (timeout[i]) {
				done = true;
				break;
				}
			if (areached[i] == false){
				done = false;
				break;
				}
			}
	    if (type == 0) complete = done;

		}

	public void update(Graphics g){
		paint(g);
		}
	}

class menu_2 extends Frame implements ItemListener, TextListener{
	Menu menu1, menu2, menu3, menu4;
	MenuBar menubar1;
	MenuItem menuitem11, menuitem12, menuitem13;
	MenuItem menuitem21, menuitem22, menuitem23;
	MenuItem menuitem31, menuitem32;
	MenuItem menuitem41, menuitem42, menuitem43;
	Choice choice2;
	Label f1, f2, f3, f4, f41, f5, f6, f7, f8, f9, f10;
	TextField total_frames, Delay, Lossatxt, Lossbtxt;
	Checkbox random;
	String s1 = "st", s2 = "nd", s3 = "rd", s4 = "th", s = "  ";


	int delay = 5;
	int end = 9;
	int initdir = 1;  //initdir = 1 => A goes first.
	int type = 0;		//ideal
	int lossnoa = 3;
	int lossnob = 3;
	boolean israndom = false;

	menu_2(String title){
		super(title);
//		setBackground(Color.lightGray);


		choice2 = new Choice();
		choice2.add("Ideal (No losses)");
		choice2.add("Lost frames");
//		choice2.add("Lost acknowledgements");
//		choice2.add("Loss of both");
		choice2.addItemListener(this);

		total_frames = new TextField(2);
		total_frames.addTextListener(this);
		total_frames.setEnabled(true);
		total_frames.setText("10");

		Delay = new TextField(5);
		Delay.addTextListener(this);
		Delay.setText("4");

		Lossatxt = new TextField(2);
		Lossatxt.addTextListener(this);
		Lossatxt.setEnabled(false);
		Lossbtxt = new TextField(2);
		Lossbtxt.addTextListener(this);
		Lossbtxt.setEnabled(false);
		Lossatxt.setText("");
		Lossbtxt.setText("");

		random = new Checkbox("Random Losses", true);
		random.addItemListener(this);
		random.setState(false);
		random.setEnabled(false);

		f1 = new Label("Click 'Done' to save changes, 'X' to cancel", Label.LEFT);
		f2 = new Label("No. of frames to send :", Label.LEFT);
		f4 = new Label("One Way Delay (mS) ", Label.LEFT);
		f5 = new Label("Type of Simulation", Label.LEFT);
		f7 = new Label("Loss of every", Label.LEFT);
		f8 = new Label(s + "   frame from sender", Label.LEFT);
		f9 = new Label("Loss of every", Label.LEFT);
		f10 = new Label(s + "   frame from receiver", Label.LEFT);

		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		setLayout(gb);

		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridheight = 1;
		gbc.gridwidth = 1;
		gbc.fill = GridBagConstraints.HORIZONTAL;

		add(f2, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(total_frames, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

/*		gbc.gridy++;
		gbc.gridx = 0;
		add(f3, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(panel, gbc);*/

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		add(f4, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(Delay, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		add(f5, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(choice2, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		add(f7, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(Lossatxt, gbc);
		gbc.gridx = 3;
		add(f8, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

/*		gbc.gridy++;
		gbc.gridx = 0;
		add(f9, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(Lossbtxt, gbc);
		gbc.gridx = 3;
		add(f10, gbc);*/

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 1;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 2;
		add(random, gbc);

		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);

/*		gbc.gridy++;
		gbc.gridx = 0;
		f6 = new Label("");
		add(f6, gbc);
		gbc.gridx = 1;
		add(f1, gbc);
  */		}


	public void textValueChanged(TextEvent event){
		if (event.getSource() == total_frames){
			String temp = total_frames.getText();
			try {
				end = Integer.parseInt(temp) - 1;
				}
			catch(NumberFormatException e){
				end = 9;
				total_frames.setText("10");
				}
			if (end < 0 || end > 200){
				end = 9;
				total_frames.setText("10");
				}
			gobackn.canvas.end = end;
			}


		if (event.getSource() == Delay){
			String temp = Delay.getText();
			float val;
			try {
				val = new Float(temp).floatValue();
				}
			catch(NumberFormatException e){
				val = 4;
				Delay.setText("4");
				}
			if (val < 0.5 || val > 20000) {
				val = 4;
				Delay.setText("4");
				}
			delay = 3 + (int) val / 2;
			}
		if (event.getSource() == Lossatxt){
			String temp = Lossatxt.getText();

			if (!Lossatxt.isEnabled()) return;
			try{
				lossnoa = Integer.parseInt(temp) - 1;
				}
			catch(NumberFormatException e){
				lossnoa = 2;
				Lossatxt.setText("3");
				}
			if (lossnoa < 1 || lossnoa > 999){
				lossnoa = 2;
				Lossatxt.setText("3");
				}
			switch ((lossnoa + 1) % 10){
				case 0 : s = s4; break;
				case 1 : s = s1; break;
				case 2 : s = s2; break;
				case 3 : s = s3; break;
				default: s = s4; break;
				}
			f8.setText(s + "   frame from sender");
			}
		if (event.getSource() == Lossbtxt){
			String temp = Lossbtxt.getText();

			if (!Lossbtxt.isEnabled()) return;
			try{
				lossnob = Integer.parseInt(temp) - 1;
				}
			catch(NumberFormatException e){
				lossnob = 2;
				Lossbtxt.setText("3");
				}
			if (lossnob < 1 || lossnob > 999){
				lossnob = 2;
				Lossbtxt.setText("3");
				}
			switch (lossnob % 10){
				case 0 : s = s4; break;
				case 1 : s = s1; break;
				case 2 : s = s2; break;
				case 3 : s = s3; break;
				default: s = s4; break;
				}
			f10.setText(s + "   frame from receiver");
			}
		}

	public void itemStateChanged(ItemEvent event){
		if (event.getItemSelectable() == choice2){
			if (((Choice)event.getItemSelectable()).getSelectedItem() .equals("Ideal (No losses)")){
				type = 0;
				random.setState(false);
				random.setEnabled(false);
				israndom = false;
				if (Lossatxt.isEnabled()) Lossatxt.setEnabled(false);
				Lossatxt.setText(" ");
				f8.setText("     frame from sender");
				if (Lossbtxt.isEnabled()) Lossbtxt.setEnabled(false);
				Lossbtxt.setText(" ");
				f10.setText("     frame from receiver");
				}
			if (((Choice)event.getItemSelectable()).getSelectedItem() .equals("Lost frames")){
				type = 1;
				if (Lossbtxt.isEnabled()) Lossbtxt.setEnabled(false);
				Lossbtxt.setText(" ");
				f10.setText("     frame from receiver");
				random.setEnabled(true);
				if (random.getState() == true) return;
				if (Lossatxt.isEnabled()) return;
				Lossatxt.setEnabled(true);
				Lossatxt.setText("3");
				}
			if (((Choice)event.getItemSelectable()).getSelectedItem() .equals("Lost acknowledgements")){
				type = 2;
				if (Lossatxt.isEnabled()) Lossatxt.setEnabled(false);
				Lossatxt.setText(" ");
				f8.setText("     frame from sender");
				random.setEnabled(true);
				if (random.getState() == true) return;
				if (Lossbtxt.isEnabled()) return;
				Lossbtxt.setEnabled(true);
				Lossbtxt.setText("3");
				}
			if (((Choice)event.getItemSelectable()).getSelectedItem() .equals("Loss of both")){
				type = 3;
				random.setEnabled(true);
				if (random.getState() == true) return;
				if (!Lossatxt.isEnabled()){
					Lossatxt.setEnabled(true);
					Lossatxt.setText("3");
					}
				if (!Lossbtxt.isEnabled()){
					Lossbtxt.setEnabled(true);
					Lossbtxt.setText("3");
					}
				}
			}
		if (event.getItemSelectable() == random){
			if (random.getState() == true){
				if (Lossatxt.isEnabled()) Lossatxt.setEnabled(false);
				Lossatxt.setText(" ");
				if (Lossbtxt.isEnabled()) Lossbtxt.setEnabled(false);
				Lossbtxt.setText(" ");
				lossnoa = ((int)(Math.random() * 100) % 3) + 1;
				lossnob = ((int)(Math.random() * 100) % 3) + 1;
				}
			if (random.getState() == false){
				switch (type){
					case 1 :
						if (Lossbtxt.isEnabled()) Lossbtxt.setEnabled(false);
						Lossbtxt.setText(" ");
						if (Lossatxt.isEnabled()) return;
						Lossatxt.setEnabled(true);
						Lossatxt.setText("3");
						break;
					case 2 :
						if (Lossatxt.isEnabled()) Lossatxt.setEnabled(false);
						Lossatxt.setText(" ");
						if (Lossbtxt.isEnabled()) return;
						Lossbtxt.setEnabled(true);
						Lossbtxt.setText("3");
						break;
					case 3 :
						Lossatxt.setEnabled(true);
						Lossatxt.setText("3");
						Lossbtxt.setEnabled(true);
						Lossbtxt.setText("3");
						break;
					default:
						break;
					}
				}
			}
		}

	public int getend(){
		return end;
		}

	public int getdelay(){
		return delay;
		}

	public int getinitdir(){
		return initdir;
		}

	public int gettype(){
		return type;
		}

	public int getlossnoa(){
		return lossnoa;
		}

	public int getlossnob(){
		return lossnob;
		}
	}


class Help extends Frame{    // window for displaying the help.

	ScrollPane scrollpane = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
	String str = "\nIntroduction\n\n"
					     + "	This applet simulates the sliding window protocol using 'Go back n'. It works for the\n"
							 + "	ideal case as well as when frame losses occur.\n\n\n"
							 + "Changing the Settings\n\n"	
					     + "	Changing the settings for the simulation is quite straightforward. Click on the 'Change\n"
					     + "	Settings' button. The caption changes to 'Done' and a window comes up which offers you a\n"
					     + "	number of options. There are textboxes in which you can type in the values and there are\n"
					     + "	also drop-down lists from which you can select the desired option just by clicking on it.\n"
					     + "	The options related to losses are available only when a loss option is selected from the\n"
					     + "	'Type of Simulation' field. When you have finished with the settings, you can exit by\n"
							 + "	clicking on the 'Done' button whose caption now reverts to the original and the options\n"	 
							 + "	window closes.\n\n\n"	
					     + "Managing the Simulation\n\n"
					     + "	To start the simulation, click on the 'Start' button. This causes the 'Stop' and 'Pause' buttons\n"
					     + "	to get enabled. As the name suggests, the 'Stop' button, when clicked, stops the simulation\n"
					     + "	and restores the screen to the state it was in before the simulation started. The simulation\n"
					     + "	can be restarted in the same way as before and the settings can be changed if required.\n"
					     + "	Clicking on the 'Pause' button during the simulation freezes the simulation. It can be\n"
							 + "	resumed by clicking on the 'Resume' button.";	
	TextArea text = new TextArea(str, 30, 77, TextArea.SCROLLBARS_NONE);
  
	Help(String title){
		super(title);
		setLayout(new BorderLayout());
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		scrollpane = new ScrollPane();
		add("Center", scrollpane);
		scrollpane.add(text);
		text.setEnabled(false);
		}

  public void processWindowEvent(WindowEvent event){
	if (event.getID() == WindowEvent.WINDOW_CLOSING)
		setVisible(false);
		}
	}

